/*
 * This file was generated automatically by ExtUtils::ParseXS version 2.18_02 from the
 * contents of Interface.xs. Do not edit this file, edit Interface.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

#line 1 "Interface.xs"
#ifdef __cplusplus
extern "C" {
#endif
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include <sys/socket.h>
#include <net/if.h>
#include <errno.h>

#ifdef __cplusplus
}
#endif

/*
** Fix up missing definition
*/

#ifndef IFHWADDRLEN
# define IFHWADDRLEN    6
#endif

/*
** Fix up non-POSIX compliant address family names
*/

#ifndef AF_FILE
# ifdef AF_UNIX
#  define AF_FILE AF_UNIX
# else
#  ifdef AF_LOCAL
#   define AF_FILE AF_LOCAL
#  endif
# endif
#endif

/*
** Fix up slightly damaged ifreq entries
*/

#ifndef ifr_mtu
#define ifr_mtu ifr_ifru.ifru_metric
#endif

/*
** Function select values for int and sockaddr access routines
*/

enum _int_fields
{
  NI_FLAGS = 1, NI_MTU, NI_METRIC, NI_IRQ
};

enum _sockaddr_fields
{
  NI_ADDR = 1, NI_BRDADDR, NI_NETMASK, NI_HWADDR, NI_DSTADDR
};

/*
** Short-cuts to reduce typing
*/

typedef struct ifreq ifreq;

typedef union sockaddr_all {
  struct sockaddr sa;
  struct sockaddr_in sin;
} sockaddr_all;

#define NI_REF_CHECK(ref) \
	if (!SvROK (ref) || !SvOBJECT (SvRV(ref)) || !SvREADONLY (SvRV(ref))) \
          croak ("Can't call method \"%s\" without a valid object reference", GvNAME (CvGV (cv)));

#define NI_CONNECT(fd) \
	if ((fd = socket (PF_INET, SOCK_DGRAM, 0)) == -1) \
	  XSRETURN_EMPTY;

#define NI_ACCESS(fd,value,buf) \
	if (ioctl (fd, value, buf) == -1) { \
	  NI_DISCONNECT (fd); \
	  XSRETURN_EMPTY; \
	}

#define NI_DISCONNECT(fd) close (fd)

#define	NI_NEW_REF(rv,sv,stash) \
	sv = newSV (0); \
	rv = sv_2mortal (newRV_noinc (sv)); \
	sv_bless (rv, stash); \
	SvGROW (sv, sizeof (ifreq)); \
	SvREADONLY_on (sv); \
	XPUSHs (rv);

#define NI_MAX_ARGS(x) \
	if (items > x) \
	  croak ("Too many arguments for method \"%s\"", GvNAME (CvGV (cv)))

#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#line 113 "Interface.c"
#ifndef _SIZEOF_ADDR_IFREQ
#define _SIZEOF_ADDR_IFREQ(ifr) (sizeof( struct ifreq ))
#endif

XS(XS_Net__Interface_interfaces); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__Interface_interfaces)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::Interface::interfaces", "ref");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	ref = ST(0);
#line 115 "Interface.xs"
    struct ifconf ifc;
    ifreq *ifr;
    ifreq *end;
    int fd, n;
    HV *stash;
    SV *rv, *sv;

#line 141 "Interface.c"
#line 123 "Interface.xs"
    {
      NI_CONNECT (fd);
#ifdef SIOCGIFCOUNT
      if (ioctl (fd, SIOCGIFCOUNT, &ifc) != -1) {
	New (0xbad, ifr, ifc.ifc_len, struct ifreq);
	ifc.ifc_req = ifr;
	ifc.ifc_len *= sizeof (ifreq);
	if (ioctl (fd, SIOCGIFCONF, &ifc) == -1) {
	  Safefree (ifr);
	  close (fd);
	  XSRETURN_EMPTY;
	}
      }
      else
#else
	  {
    // SIOCGIFCOUNT is unimplemented under Linux,
	// let\'s call SIOCGIFCONF(0) to get number of interfaces
    ifc.ifc_len = 0; ifc.ifc_buf = NULL; ifc.ifc_req = NULL;
    if (ioctl (fd, SIOCGIFCONF, &ifc) != -1 && ifc.ifc_len != 0) {
         // allocate enough space
         n = ifc.ifc_len / sizeof (struct ifreq);
         New (0xbad, ifr, ifc.ifc_len, struct ifreq);
         ifc.ifc_req = ifr;
         if (ioctl (fd, SIOCGIFCONF, &ifc) == -1) {
              perror("SIOCGIFCONF");
              XSRETURN_EMPTY;
         }
    } else
#endif
	{
	  n = 3;
	  New (0xbad, ifr, n, ifreq);
	  do {
	    n *= 2;
	    Renew (ifr, n, ifreq);
	    ifc.ifc_req = ifr;
	    ifc.ifc_len = n * sizeof (ifreq);
	  }
	  while (ioctl (fd, SIOCGIFCONF, &ifc) == -1 || 
		 ifc.ifc_len == n * sizeof (ifreq));
	  NI_DISCONNECT (fd);
	}
      stash = SvROK (ref) ? SvSTASH (SvRV (ref)) : gv_stashsv (ref, 0);
      ifr= (struct ifreq *) ifc.ifc_req;
      end= (struct ifreq *) ((char *) ifr + ifc.ifc_len);
      while (ifr < end) {
	NI_NEW_REF (rv, sv, stash);
	Move (ifr, SvPVX (sv), 1, ifreq);
        ifr= (struct ifreq *)((char *)ifr + _SIZEOF_ADDR_IFREQ( *ifr ) );
      }
      Safefree (ifc.ifc_req);
    }
#line 196 "Interface.c"
	PUTBACK;
	return;
    }
}


XS(XS_Net__Interface_new); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__Interface_new)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 183 "Interface.xs"
    SV *rv, *sv;
    HV *stash;
    int fd;

#line 220 "Interface.c"
#line 188 "Interface.xs"
    {
      NI_MAX_ARGS (2);
      stash = SvROK (ST (0)) ? SvSTASH (SvRV (ST (0))) : 
	gv_stashsv (ST (0), 0);
      NI_NEW_REF (rv, sv, stash);
      Move (SvPV (ST (1), PL_na), ((ifreq *) SvPVX (sv))->ifr_name, 
	    SvCUR (ST (1)) + 1, char);
      NI_CONNECT (fd);
      NI_ACCESS (fd, SIOCGIFFLAGS, SvPVX (sv));
      NI_DISCONNECT (fd);
      XSRETURN (1);
    }
#line 234 "Interface.c"
	PUTBACK;
	return;
    }
}


XS(XS_Net__Interface_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__Interface_name)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 207 "Interface.xs"
    {
      NI_MAX_ARGS (1);
      NI_REF_CHECK (ST (0));
      XSRETURN_PV (SvPVX (SvRV (ST (0))));
    }
#line 259 "Interface.c"
	PUTBACK;
	return;
    }
}


XS(XS_Net__Interface__int_value); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__Interface__int_value)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 219 "Interface.xs"
    int fd;
    ifreq *ifr;

#line 283 "Interface.c"
#line 229 "Interface.xs"
    {
      NI_MAX_ARGS (2);
      NI_REF_CHECK (ST (0));
      NI_CONNECT (fd);
      ifr = (ifreq *) SvPVX (SvRV (ST (0)));
      ST (0) = &PL_sv_undef;
      switch (ix) {
      case NI_FLAGS:
	NI_ACCESS (fd, SIOCGIFFLAGS, ifr);
	XST_mIV (0, ifr->ifr_flags);
	break;

      case NI_MTU:
	NI_ACCESS (fd, SIOCGIFMTU, ifr);
	XST_mIV (0, ifr->ifr_mtu);
	break;

      case NI_METRIC:
	NI_ACCESS (fd, SIOCGIFMETRIC, ifr);
	XST_mIV (0, ifr->ifr_metric);
	break;

      case NI_IRQ:
	NI_ACCESS (fd, SIOCGIFMAP, ifr);
	XST_mIV (0, ifr->ifr_map.irq);
	break;

      }
      if (items == 2) {
	switch (ix) {
	case NI_FLAGS:
	  ifr->ifr_flags = SvIV (ST (1));
	  NI_ACCESS (fd, SIOCSIFFLAGS, ifr);
	  break;

	case NI_MTU:
	  ifr->ifr_mtu = SvIV (ST (1));
	  NI_ACCESS (fd, SIOCSIFMTU, ifr);
	  break;

	case NI_METRIC:
	  ifr->ifr_metric = SvIV (ST (1));
	  NI_ACCESS (fd, SIOCSIFMETRIC, ifr);
	  break;
	}
      }
      NI_DISCONNECT (fd);
      XSRETURN (1);
    }
#line 334 "Interface.c"
	PUTBACK;
	return;
    }
}


XS(XS_Net__Interface__addr_value); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__Interface__addr_value)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 285 "Interface.xs"
    int fd, array = 0;
    ifreq *ifr;
    sockaddr_all sa;

#line 359 "Interface.c"
#line 297 "Interface.xs"
    {
      NI_MAX_ARGS (2);
      NI_REF_CHECK (ST (0));
      NI_CONNECT (fd);
      ifr = (ifreq *) SvPVX (SvRV (ST (0)));
      ST (0) = &PL_sv_undef;
      switch (ix) {
      case NI_ADDR:
	NI_ACCESS (fd, SIOCGIFADDR, ifr);
	break;

      case NI_BRDADDR:
	NI_ACCESS (fd, SIOCGIFBRDADDR, ifr);
	break;

      case NI_NETMASK:
	NI_ACCESS (fd, SIOCGIFNETMASK, ifr);
	break;
#ifdef SIOCGIFHWADDR
      case NI_HWADDR:
      NI_ACCESS (fd, SIOCGIFHWADDR, ifr);
      break;
#endif
      case NI_DSTADDR:
	NI_ACCESS (fd, SIOCGIFDSTADDR, ifr);
	break;
      }
      Move (&(ifr->ifr_addr), &sa, 1, sockaddr_all);
      if (items == 2) {
	switch (ix) {
	case NI_ADDR:
	  NI_ACCESS (fd, SIOCGIFADDR, ifr);
	  break;

	case NI_BRDADDR:
	  NI_ACCESS (fd, SIOCGIFBRDADDR, ifr);
	  break;

	case NI_NETMASK:
	  NI_ACCESS (fd, SIOCGIFNETMASK, ifr);
	  break;
/*
#ifdef SIOCGIFHWADDR
	case NI_HWADDR:
	  NI_ACCESS (fd, SIOCGIFHWADDR, ifr);
	  break;
#endif
*/
	case NI_DSTADDR:
	  NI_ACCESS (fd, SIOCGIFDSTADDR, ifr);
	  break;
	}
      }
      NI_DISCONNECT (fd);
      array = (GIMME_V == G_ARRAY);
      if (array) {
	EXTEND (sp, 2);
	PUSHs (sv_2mortal (newSViv (sa.sa.sa_family)));
      }
      switch (sa.sa.sa_family) {
      case AF_INET:
	if (array)
	  PUSHs (sv_2mortal (newSViv (sizeof (sa.sin.sin_addr))));
	PUSHs (sv_2mortal (newSVpv ((char *) &sa.sin.sin_addr,
				      sizeof (sa.sin.sin_addr))));
	break;

      case AF_FILE:
	if (array)
/*Does not work */
/*	  PUSHs (sv_2mortal (newSViv (sizeof (sa.sin.sin_addr))));*/
/* Bad hack to get hardware address, copied INET mechanism from above,
   returned last four digits of MAC, munge address and abs size to 6 */
	  PUSHs (sv_2mortal (newSViv (IFHWADDRLEN)));
	PUSHs (sv_2mortal (newSVpv ((char *) (&sa.sa.sa_data),
				      IFHWADDRLEN)));
      }
    }
#line 439 "Interface.c"
	PUTBACK;
	return;
    }
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_Net__Interface); /* prototype to pass -Wmissing-prototypes */
XS(boot_Net__Interface)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    char* file = __FILE__;

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    XS_VERSION_BOOTCHECK ;

    {
        CV * cv ;

        newXSproto("Net::Interface::interfaces", XS_Net__Interface_interfaces, file, "$");
        newXSproto("Net::Interface::new", XS_Net__Interface_new, file, "$$");
        newXSproto("Net::Interface::name", XS_Net__Interface_name, file, "$");
        cv = newXS("Net::Interface::mtu", XS_Net__Interface__int_value, file);
        XSANY.any_i32 = NI_MTU ;
        sv_setpv((SV*)cv, "$;$") ;
        cv = newXS("Net::Interface::flags", XS_Net__Interface__int_value, file);
        XSANY.any_i32 = NI_FLAGS ;
        sv_setpv((SV*)cv, "$;$") ;
        cv = newXS("Net::Interface::_int_value", XS_Net__Interface__int_value, file);
        XSANY.any_i32 = 0 ;
        sv_setpv((SV*)cv, "$;$") ;
        cv = newXS("Net::Interface::irq", XS_Net__Interface__int_value, file);
        XSANY.any_i32 = NI_IRQ ;
        sv_setpv((SV*)cv, "$;$") ;
        cv = newXS("Net::Interface::metric", XS_Net__Interface__int_value, file);
        XSANY.any_i32 = NI_METRIC ;
        sv_setpv((SV*)cv, "$;$") ;
        cv = newXS("Net::Interface::hwaddress", XS_Net__Interface__addr_value, file);
        XSANY.any_i32 = NI_HWADDR ;
        sv_setpv((SV*)cv, "$;$") ;
        cv = newXS("Net::Interface::broadcast", XS_Net__Interface__addr_value, file);
        XSANY.any_i32 = NI_BRDADDR ;
        sv_setpv((SV*)cv, "$;$") ;
        cv = newXS("Net::Interface::_addr_value", XS_Net__Interface__addr_value, file);
        XSANY.any_i32 = 0 ;
        sv_setpv((SV*)cv, "$;$") ;
        cv = newXS("Net::Interface::destination", XS_Net__Interface__addr_value, file);
        XSANY.any_i32 = NI_DSTADDR ;
        sv_setpv((SV*)cv, "$;$") ;
        cv = newXS("Net::Interface::netmask", XS_Net__Interface__addr_value, file);
        XSANY.any_i32 = NI_NETMASK ;
        sv_setpv((SV*)cv, "$;$") ;
        cv = newXS("Net::Interface::address", XS_Net__Interface__addr_value, file);
        XSANY.any_i32 = NI_ADDR ;
        sv_setpv((SV*)cv, "$;$") ;
    }
    if (PL_unitcheckav)
         call_list(PL_scopestack_ix, PL_unitcheckav);
    XSRETURN_YES;
}

